import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;

/**
* LodeRunner Game
* @author Roman Podobedov (<a href="mailto:romka@ut.ee">romka@ut.ee</a>) - Main developer, Programmer<BR>
* Vitaly Petrov (<a href="mailto:petrov@ut.ee">petrov@ut.ee</a>) - Programmer<BR>
* Nadezda Velikanova (<a href="mailto:nadin@ut.ee">nadin@ut.ee</a>) - Additional Programming<BR>
* Darja Krushevskaja (<a href="mailto:dasha@ut.ee">dasha@ut.ee</a>) - Additional Programming<BR>
* Alina Klunduk (<a href="mailto:maljok@ut.ee">maljok@ut.ee</a>) - Additional Programming<BR>
* @version 1.0
*/

public class CLodeRunner extends Applet implements KeyListener, Runnable
{
	// Cell width and height (constants)
	protected int CellWidth = 16;
	protected int CellHeight = 16;

	protected int width, height;
	
	protected Image images[];
	protected Image BackBuffer;
	protected Graphics BackBufferGC;
	protected boolean ImageLoaded = false;
	protected URL level_base;

	protected int level_num; // Current level number
	protected boolean new_level; // true if begining new level
	protected int new_level_counter; // new level counter
	protected boolean game_over;
	protected int game_over_counter;

	boolean step_right=false, step_left=false, step_up=false, step_down=false, step_hit=false;
	
	CEngine engine; // Main engine
	Thread timer;

	/** 
	* Applet initialization
	*/
	public void init()
	{
        timer = null;

		new_level = true; // Set New level flag
		game_over = false;

		images = new Image[49]; // Allocate space for images
		engine = new CEngine();
		engine.SetCellParam(CellWidth, CellHeight); // Set some parameters to engine

		// Try to get images fron network
		try
		{
			images[0] = getImage(new java.net.URL(getCodeBase(), "images/wall.gif"));
			images[1] = getImage(new java.net.URL(getCodeBase(), "images/wall.gif"));
			images[2] = getImage(new java.net.URL(getCodeBase(), "images/wall_beton.gif"));
			images[3] = getImage(new java.net.URL(getCodeBase(), "images/staircase.gif"));
			images[4] = getImage(new java.net.URL(getCodeBase(), "images/box.gif"));
			images[5] = getImage(new java.net.URL(getCodeBase(), "images/rope.gif"));

			images[6] = getImage(new java.net.URL(getCodeBase(), "images/man.gif"));

			images[7] = getImage(new java.net.URL(getCodeBase(), "images/man_left1.gif"));
			images[8] = getImage(new java.net.URL(getCodeBase(), "images/man_left2.gif"));
			images[9] = getImage(new java.net.URL(getCodeBase(), "images/man_left3.gif"));

			images[10] = getImage(new java.net.URL(getCodeBase(), "images/man_right1.gif"));
			images[11] = getImage(new java.net.URL(getCodeBase(), "images/man_right2.gif"));
			images[12] = getImage(new java.net.URL(getCodeBase(), "images/man_right3.gif"));

			images[13] = getImage(new java.net.URL(getCodeBase(), "images/man.gif"));
			images[14] = getImage(new java.net.URL(getCodeBase(), "images/man.gif"));
			images[15] = getImage(new java.net.URL(getCodeBase(), "images/man.gif"));

			images[16] = getImage(new java.net.URL(getCodeBase(), "images/man.gif"));
			images[17] = getImage(new java.net.URL(getCodeBase(), "images/man.gif"));
			images[18] = getImage(new java.net.URL(getCodeBase(), "images/man.gif"));

			images[19] = getImage(new java.net.URL(getCodeBase(), "images/man_rope_left1.gif"));
			images[20] = getImage(new java.net.URL(getCodeBase(), "images/man_rope_left2.gif"));
			images[21] = getImage(new java.net.URL(getCodeBase(), "images/man_rope_left3.gif"));

			images[22] = getImage(new java.net.URL(getCodeBase(), "images/man_rope_right1.gif"));
			images[23] = getImage(new java.net.URL(getCodeBase(), "images/man_rope_right2.gif"));
			images[24] = getImage(new java.net.URL(getCodeBase(), "images/man_rope_right3.gif"));

			images[25] = getImage(new java.net.URL(getCodeBase(), "images/pit1.gif"));
			images[26] = getImage(new java.net.URL(getCodeBase(), "images/pit2.gif"));
			images[27] = getImage(new java.net.URL(getCodeBase(), "images/pit3.gif"));
			images[28] = getImage(new java.net.URL(getCodeBase(), "images/pit4.gif"));
			images[29] = getImage(new java.net.URL(getCodeBase(), "images/pit5.gif"));


			images[30] = getImage(new java.net.URL(getCodeBase(), "images/enemy.gif"));

			images[31] = getImage(new java.net.URL(getCodeBase(), "images/enemy_left1.gif"));
			images[32] = getImage(new java.net.URL(getCodeBase(), "images/enemy_left2.gif"));
			images[33] = getImage(new java.net.URL(getCodeBase(), "images/enemy_left3.gif"));

			images[34] = getImage(new java.net.URL(getCodeBase(), "images/enemy_right1.gif"));
			images[35] = getImage(new java.net.URL(getCodeBase(), "images/enemy_right2.gif"));
			images[36] = getImage(new java.net.URL(getCodeBase(), "images/enemy_right3.gif"));

			images[37] = getImage(new java.net.URL(getCodeBase(), "images/enemy.gif"));
			images[38] = getImage(new java.net.URL(getCodeBase(), "images/enemy.gif"));
			images[39] = getImage(new java.net.URL(getCodeBase(), "images/enemy.gif"));

			images[40] = getImage(new java.net.URL(getCodeBase(), "images/enemy.gif"));
			images[41] = getImage(new java.net.URL(getCodeBase(), "images/enemy.gif"));
			images[42] = getImage(new java.net.URL(getCodeBase(), "images/enemy.gif"));

			images[43] = getImage(new java.net.URL(getCodeBase(), "images/enemy_rope_left1.gif"));
			images[44] = getImage(new java.net.URL(getCodeBase(), "images/enemy_rope_left2.gif"));
			images[45] = getImage(new java.net.URL(getCodeBase(), "images/enemy_rope_left3.gif"));

			images[46] = getImage(new java.net.URL(getCodeBase(), "images/enemy_rope_right1.gif"));
			images[47] = getImage(new java.net.URL(getCodeBase(), "images/enemy_rope_right2.gif"));
			images[48] = getImage(new java.net.URL(getCodeBase(), "images/enemy_rope_right3.gif"));

		
		}
		catch(java.net.MalformedURLException e)
		{

		}
		
		// Get dimenstions of applet
		Dimension dimens = getSize();
		width = dimens.width;
		height = dimens.height;

		// Create second buffer for double buffering technque
		BackBuffer = createImage(width, height);
		BackBufferGC = BackBuffer.getGraphics();
		
		// And draw all images on the back buffer
		for (int i=0; i<49; i++) BackBufferGC.drawImage(images[i], 0, 0, this);

		addKeyListener(this);
		requestFocus();

		// Initialize start parameters
		level_num = 1;
		new_level = true;
		new_level_counter = 100;
	}

	/** 
	* Image update method (here we wait while all images are loaded)
	*/
	public boolean imageUpdate(Image img, int infoflags, int x, int y, int w, int h)
	{
		if (infoflags == ALLBITS)
		{
			ImageLoaded = true;
			repaint();
			return false;
		}
		return true;
	}

	/** 
	* Applet destroy method
	*/
	public void destroy()
	{
        timer = null;
	}

	/** 
	* Draw method
	*/
	public void paint(Graphics g)
	{
		byte image_num;

		Graphics newg = g;
			
		// Now draw only on back buffer
		g = BackBufferGC;
			
		// Fill all area by black color
		g.setColor(Color.black);
		g.fillRect(0, 0, width, height);
	
		// Wait while all images are loaded
		if (ImageLoaded == false)
		{
			g.setColor(Color.black);
			g.fillRect(0, 0, width, height);
			g.setFont(new Font("TimesRoman", Font.BOLD, 24));
			g.setColor(Color.white);	
			g.drawString("Loading game...", 190, 175);

			for (int i=0; i<49; i++)
				g.drawImage(images[i], 0, 0, this);
			g.setColor(Color.black);
			g.fillRect(0, 0, 16, 16);
			newg.drawImage(BackBuffer, 0, 0, null);
			return;
		}

		// If game over
		if (game_over)
		{
			g.setColor(Color.black);
			g.fillRect(0, 0, width, height);
			g.setFont(new Font("TimesRoman", Font.BOLD, 24));
			g.setColor(Color.white);	
			g.drawString("Game Over", 200, 160);
			g.drawString("Your Score: " + engine.score, 180, 185);
			newg.drawImage(BackBuffer, 0, 0, null);
			ResetAllMovements();

			game_over_counter--;
			if (game_over_counter <= 0)
			{
				engine.Init();
				game_over = false;
				level_num = 1;
				new_level = true;
				new_level_counter = 100;
			}
			return;
		}

		// If new level started
		if (new_level)
		{
			new_level_counter--;
			if (new_level_counter <= 0) 
			{
				new_level = false;
				// Load and start new level
				try
				{
					// Set URL for level
					level_base = new URL(getCodeBase(), "levels/level"+level_num+".dat");
				}
				catch(MalformedURLException e){}
				try
				{
					// Start our engine
					engine.Engine_Start(level_base);
				}
			 	catch (Exception e) {}
			}

			g.setColor(Color.black);
			g.fillRect(0, 0, width, height);
			g.setFont(new Font("TimesRoman", Font.BOLD, 24));
			g.setColor(Color.white);	
			g.drawString("Level " + level_num, 220, 175);
			newg.drawImage(BackBuffer, 0, 0, null);
			ResetAllMovements();
			return;
		}

		// Draw level
		for (int i=0; i<22; i++)
			for (int j=0; j<32; j++)
			{
				if (engine.level.ObjectInPit(j, i)) continue;
				image_num = engine.level.GetXY(j, i);
				if ((image_num > 0) && (image_num < 7)) g.drawImage(images[image_num-1], j*CellWidth, i*CellHeight, this);
			}
		
		// Draw all pits
		CPit temp_pit;

		temp_pit = engine.level.pits;
		while (temp_pit != null)
		{
		
			if (temp_pit.sprite_num > 0)
			{
				g.drawImage(images[24+temp_pit.sprite_num], temp_pit.x*CellWidth, temp_pit.y*CellHeight, this);			
			}
			temp_pit = temp_pit.next;
		}

	    g.setXORMode(getForeground());
			
		// Draw our hero
		if (engine.man.GetDirection() == 4)
			g.drawImage(images[6], engine.man.GetPosX(), engine.man.GetPosY(), this);
		else
		{
			if ((engine.man.onRope) && (engine.man.GetDirection() < 2)) // Draw when man is on rope
				g.drawImage(images[19+engine.man.GetDirection()*3+engine.man.GetSpriteNum()], engine.man.GetPosX(), engine.man.GetPosY(), this);
			else // Draw standard man
				g.drawImage(images[7+engine.man.GetDirection()*3+engine.man.GetSpriteNum()], engine.man.GetPosX(), engine.man.GetPosY(), this);
		}
	    
		boolean draw_flag;
			
		// Draw enemies
		for (int i=0; i<engine.level.total_enemy; i++)
		{
			draw_flag = true;
			for (int j=0; j<i; j++)
			{
				if ((engine.enemies[i].GetPosX() == engine.enemies[j].GetPosX()) &&
				   (engine.enemies[i].GetPosY() == engine.enemies[j].GetPosY())) 
				   {
						draw_flag = false;
						break;
				   }
			}

			if (draw_flag) // draw enemy if needed
			{
				if (engine.enemies[i].GetDirection() == 4)
					g.drawImage(images[30], engine.enemies[i].GetPosX(), engine.enemies[i].GetPosY(), this);
				else
				{
					if ((engine.enemies[i].onRope) && (engine.enemies[i].GetDirection() < 2)) // Draw when man is on rope
						g.drawImage(images[43+engine.enemies[i].GetDirection()*3+engine.enemies[i].GetSpriteNum()], engine.enemies[i].GetPosX(), engine.enemies[i].GetPosY(), this);
					else // Draw standard man
						g.drawImage(images[31+engine.enemies[i].GetDirection()*3+engine.enemies[i].GetSpriteNum()], engine.enemies[i].GetPosX(), engine.enemies[i].GetPosY(), this);
				}
			}
		}
			
		g.setPaintMode();
		g.setColor(Color.white);
		g.setFont(new Font("TimesRoman", Font.PLAIN, 12));
		g.drawString("Score: "+engine.score+"  Lives: "+engine.lives+"  Level: "+level_num, 0, 362);
		// Draw back buffer on the screen
		newg.drawImage(BackBuffer, 0, 0, null);
	}
	
	/** 
	* Applet update method
	*/
	public void update(Graphics g)
	{
		paint(g);
	}

	/** 
	* Called, when applet is started
	*/
	public void start()
	{
		timer = new Thread(this);
		timer.start();
	}

	/** 
	* Called, when applet stopped
	*/
	public void stop()
	{
        timer = null;
	}
	
	/** 
	* Called, when thread is running
	*/
	public void run()
	{
		while (true)
		{
			if (!engine.DoCalculations())
			{
				// Hero is dead :-(
				if (engine.hero_is_dead)
				{
					// Start our engine again
					engine.lives--;

					//End game, if not enought lives
					if (engine.lives<=0)
					{
						game_over = true;
						game_over_counter = 100;
						new_level = true;
						repaint();
					}
					try
					{
						engine.Engine_Start(level_base);
					}
	 				catch (Exception e)
					{
					}
				}

				if (engine.level_is_complete)
				{
					// Start new level
					engine.started = false;
					engine.level_is_complete = false;
					level_num++;
					new_level = true;
					new_level_counter = 100;
					if (level_num > 50)
					{
						// ALL LEVELS ARE COMPLETED, Game Over
						game_over = true;
						game_over_counter = 100;
						level_num = 1;
						repaint();
					}
				}
			
				// Hero movement
				if ((!game_over) && (!new_level))
				{

					// Move our hero
					if (step_left)
					{
						step_left = false;
						engine.StepLeft();
					}
			
					if (step_right)
					{
						step_right = false;
						engine.StepRight();
					}
			
					if (step_up)
					{
						step_up = false;
						engine.StepUp();
					}
			
					if (step_down)
					{
						step_down = false;
						engine.StepDown();
					}

					// If Space is pressed
					if (step_hit)
					{
						step_hit = false;
						engine.Hit();
					}
				}
			}
			else ResetAllMovements();
			
			// Repaint our screen
			repaint();

			try
			{
				Thread.currentThread().sleep(40);
			}
			catch (InterruptedException e) {}
		}
    }

	/** 
	* Called, when key in applet is pressed
	*/
	public void keyPressed(KeyEvent key_event)
	{		
		// Get key code
		int code = key_event.getKeyCode();
		if (code == 0) code = key_event.getKeyCode();

		if (code == KeyEvent.VK_LEFT) step_left=true;
		else
		if (code == KeyEvent.VK_RIGHT) step_right=true;
		else
		if (code == KeyEvent.VK_UP) step_up=true;
		else
		if (code == KeyEvent.VK_DOWN) step_down=true;
		else
		if (code == KeyEvent.VK_SPACE) step_hit=true;
	}

	/** 
	* Called, when key in applet is released
	*/
	public void keyReleased(KeyEvent key_event)
	{
	
	}

	/** 
	* Called, when key in applet is typed
	*/
	public void keyTyped(KeyEvent key_event)
	{
	
	}

	/** 
	* Reset all hero movements
	*/
	public void ResetAllMovements()
	{
		// Reset all movements
		step_left = false;
		step_right = false;
		step_up = false;
		step_down = false;
		step_hit = false;
	}
}
